#include "stdio.h"
#include "string.h"
#include "stdlib.h"
#include "variables35.h"
#include "siemens35.h"

#define WORD unsigned int

//wysanie numeru PIN do telefonu, ustawienie sposobu powiadamiania
void initgsm()
{
	printf("%s\n",CPIN);
	gets(&UDbuf);
	delay(5000);
	delay(5000);
	printf("%s\n",ECHOOFF);
	gets(&UDbuf);
	printf("%s\n",SETNOTICE);
	gets(&UDbuf);
}


//wysanie wiadomoci SMS
void sendsms(generic char *tekst)
{
	char len, i, n, ch_1, ch_2;

	n = len = strlen(tekst);								//obliczenie dugoci acucha znakw po zakodowaniu
	i = n / 8;													//liczc od "pierwszego oktetu"
	n = i * 7 + i % 8 + 13;
	printf("%s%d\n", SMSSEND, n);
	while(_getkey() != '>');								//oczekiwanie na znak "zachty"
	printf("%02X%02X%s%02X%02X%02X%02X%s%02X%02X%02X%02X", LOSCA, TOSCA, SCA, FO, MR, LODA, TODA, DA, PID, DCS, SCTS, len);
	i = 0;
	while (i < len)
	{
		ch_1 = *(tekst + i);									//pobranie pierwszego znaku tekstu
		ch_2 = *(tekst + i + 1);							//pobranie nastpujcego za nim znaku
		n = i % 8;												//obliczenie iloci przesuni
		ch_1 >>= n;												//przesunicie pierwszego znaku w prawo
		n = 7-n;													//wyliczenie dopenienia liczby przesni dla 2-go znaku
		ch_2 <<= n;												//przesunicie drugiego znaku w lewo
		ch_1 += ch_2;											//wyliczenie kodu nowo powstaego znaku
		printf("%02X", ch_1);								//wysania znaku szesnastkowego
		i++;														//nastpna pozycja w acuchu
		if (n == 1) i++;										//dla kadego 8-go znaku przesunicie o 1, znak jest "gubiony"
	}                             	
	putchar(0x1A);												//wysanie znaku koca EOT+CR+LF
	putchar(0x0D);
}


//pobiera liczbe szesnastkow w postaci tekstu spod wskazanego adresu i wykonuje konwersj
//na typ unsigned int (WORD)
WORD str2num(generic char *addr)
{
	data char temp[2];
	WORD num;
	
	temp[0] = *addr;
	temp[1] = *(addr+1);
	sscanf(temp, "%X", &num);
	return (num);
}


//odbir wiadomoci SMS
void receivesms(generic char *tekst)
{
	WORD i;
	char ch_1, ch_2, n, pos;
	data char temp[20];
	generic char *ptr;
	
	ptr = tekst;												//bufor posuy do zapamietywania tekstu
	gets(tekst);												//oczekiwanie na powiadomienie zgodne z wzorcem w NOTICE
	if (strncmp(tekst, &NOTICE, 6) == 0)
	{
		sscanf((tekst+12), "%i", &i);						//wyodrbnienie indeksu w pamici
		printf("%s%c%c\n", CHOOSEMEM, *(tekst+8), *(tekst+9));	//wybr pamici do odczytu SMS
		gets(temp);												//pobranie informacji o statusie CPMS
		gets(temp);												//pobranie OK
		printf("%s%i\n", SMSREAD, i);				
		gets(tekst);											//pobranie SMS
		gets(temp);												//pobranie OK
		printf("%s%i\n", SMSDEL, i);						//usunicie SMS z pamici telefonu
		gets(temp);												//pobranie OK
		
		i = str2num(tekst);									//przesunicie wskanika poza numer SCA (centrum usug)
		tekst += 2 * i + 4;									//i pierwszy oktet
		
		i = str2num(tekst);									//przesunicie wskanika poza pola: typ numeru nadawcy, numer
		tekst += 22 + i + i % 2;							//nadawcy,id.protokou,schemat kodowania,znacznik czasu
		
		i = str2num(tekst);									//wyznaczenie dugoci acucha
		tekst += 2;												//wskazanie do pierwszej pozycji tekstu SMS
		
		while (pos < i) 										//dopki nie przekroczono rozmiaru acucha
		{
			ch_1 = str2num(tekst);							//zamiana acucha na kod znaku
			n = pos % 8;										//obliczenie liczby przesuni dla 1-go znaku
			ch_1 <<= n;											//przesunicie 1-go znaku w lewo n razy
			ch_1 += ch_2;										//maskowanie najstarszego bitu oraz uwzgldnienie bitw
			ch_1 &= 0x7F;										//przeniesienia (przy kodowaniu)
			*ptr = ch_1;										//zapis wyliczonego kodu znaku do bufora
			ptr++;												//nastpna pozycja w buforze
			n = 7 - n;											//wyliczenie iloci przesuni nastpnego znaku dla odzyskania
			ch_2 = str2num(tekst) >> n;					//bitw utraconych przy kodowaniu
			if (n == 0) 										//cyklicznie - 8 znak brany jest w caoci
			{
				ch_2 = 0;
				tekst -= 2;
			}
			pos++;												//nastpna pozycja w dekodowanym cigu
			tekst += 2;
		}
		*ptr = 0;												//zapis znaku koca acucha
	}
}



